/*
 * Copyright (C) 2002-2007 The Warp Rogue Team
 * Part of the Warp Rogue Project
 *
 * This software is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License.
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY.
 *
 * See the license.txt file for more details.
 */

/*
 * Module Name: Help
 * Description: -
 */

#define Uses_Ui
#define Uses_DataFile
#include "mheader.h"

#include "help.h"


#define N_HELP_FILES		15


typedef struct help_content_struct	HELP_CONTENT;

struct help_content_struct {

	char *	text_title;

	char *	file_name;

};


static void		additional_information_screen(void);



static HELP_CONTENT	HelpContent[N_HELP_FILES] = {

	{"Stats",			FILE_HELP_STATS},
	{"Perks",			FILE_HELP_PERKS},
	{"Status",			FILE_HELP_STATUS},
	{"Parties",			FILE_HELP_PARTIES},
	{"Advancement",			FILE_HELP_ADVANCEMENT},
	{"Timing",			FILE_HELP_TIMING},
	{"Movement",			FILE_HELP_MOVEMENT},
	{"Combat",			FILE_HELP_COMBAT},
	{"Evocation",			FILE_HELP_EVOCATION},
	{"Psychic Powers",		FILE_HELP_PSYCHIC_POWERS},
	{"Tactical Commands",		FILE_HELP_TACTICS},
	{"Objects",			FILE_HELP_OBJECTS},
	{"Terrain",			FILE_HELP_TERRAIN},
	{"Macros",			FILE_HELP_MACROS},
	{"Hints",			FILE_HELP_HINTS}

};



/*
 * the help screen
 */
void help_screen(void)
{

	command_bar_set(2, CM_ADDITIONAL_INFORMATION, CM_EXIT);

	render_help_screen();

	update_screen();

	if (command_bar_get_command() == CM_EXIT) {
		return;
	}

	additional_information_screen();
}



/*
 * the additional information screen
 */
static void additional_information_screen(void)
{
	LIST *items;
	MENU *menu;
	int i;

	items = list_new();

	for (i = 0; i < N_HELP_FILES; i++) {

		list_add(items, HelpContent[i].text_title);
	}

	menu = menu_create(items);

	while (true) {
		command_bar_set(4, CM_UP, CM_DOWN, CM_OK, CM_EXIT);

		render_additional_information_screen();

		additional_information_screen_menu(menu);

		if (menu->entered_command == CM_EXIT) {

			break;
		}

		show_text_file(
			HelpContent[menu->highlighted].text_title,
			HelpContent[menu->highlighted].file_name,
			false
		);
	}

	menu_destroy(menu);
}



